﻿Imports System.ComponentModel
Imports System.Text
Imports GrapeCity.ActiveAnalysis
Imports GrapeCity.ActiveAnalysis.DataSources
Imports GrapeCity.ActiveAnalysis.Data
Imports GrapeCity.ActiveAnalysis.Schema
Imports GrapeCity.ActiveAnalysis.Layout

Namespace GetSelectedFilterSample
	Partial Public Class Form1
		Inherits Form

		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

		End Sub

		Private Sub pivotView1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles pivotView1.Load
			Dim localCubeDataSource2 As New GrapeCity.ActiveAnalysis.DataSources.LocalCubeDataSource()
			localCubeDataSource2.LocalCubeFile = Application.StartupPath & "../../../NwindLocalCube.ddacube"
			localCubeDataSource2.Connect()
			Me.pivotView1.DataSource = localCubeDataSource2
		End Sub

		Private Sub pivotView1_ModelChanged(ByVal sender As Object, ByVal e As EventArgs) Handles pivotView1.ModelChanged




			For Each filter As IFieldFilter In pivotView1.GetLayoutState().Filters
				lstFilterList.Items.Add(CType(filter, Object).ToString())

				If CType(filter, Object).ToString().Contains("MemberFilter") Then ' Check of the Filter Item contains the string MemberFilter

					Dim member As IMemberFilter = CType(filter, IMemberFilter) ' Typecase Filter item to instance of IMemberFilter

					Dim Schemamember As IEnumerable(Of GrapeCity.ActiveAnalysis.Schema.Member) = member.RootMembers

					For Each members In Schemamember 'Iterate through all members and and check if a member was selected

						lstMemberFilter.Items.Add("Filter Name" & CType(filter, Object).ToString())
						lstMemberFilter.Items.Add("Caption:" & members.Caption)
						lstMemberFilter.Items.Add("Is Included:" & member.IsMemberIncluded(members))
						lstMemberFilter.Items.Add("----------------------------------------------------")


					Next members
				End If


				If CType(filter, Object).ToString().Contains("TopNFilter") Then ' Check of the Filter Item contains the string TopNFilter

					Dim TopN As ITopNFilter = CType(filter, ITopNFilter) 'Typecase Filter item to instance of ITopNFilter


					lstTopNFilter.Items.Add("Filter Name" & CType(filter, Object).ToString())
					lstTopNFilter.Items.Add("Value:" & TopN.Value.ToString())
					lstTopNFilter.Items.Add("Expression:" & TopN.Expression)
					lstTopNFilter.Items.Add("Unique Field Name:" & TopN.FieldUniqueName)
					lstTopNFilter.Items.Add("----------------------------------------------------")

				End If
					If CType(filter, Object).ToString().Contains("RangeFilter") Then ' Check of the Filter Item contains the string RangeFilter



						Dim range As IRangeFilter = CType(filter, IRangeFilter) ' Typecase Filter item to instance of IRangeFilter

						lstRangeFilter.Items.Add("Filter Name :" & CType(filter, Object).ToString())
						lstRangeFilter.Items.Add("Start Value :" & range.StartValue)
						lstRangeFilter.Items.Add("End Value :" & range.EndValue)
						lstRangeFilter.Items.Add("Unique Field Name : " & range.FieldUniqueName)
						lstRangeFilter.Items.Add("----------------------------------------------------")



					End If

					If CType(filter, Object).ToString().Contains("ValueFilter") Then ' Check of the Filter Item contains the string ValueFilter

						Dim valuef As IValueFilter = CType(filter, IValueFilter) ' Typecase Filter item to instance of IValueFilter



						lstValueFilter.Items.Add("Filter Name :" & CType(filter, Object).ToString())
						lstValueFilter.Items.Add("Value :" & valuef.Value)
						lstValueFilter.Items.Add("End Value :" & valuef.EndValue)
						lstValueFilter.Items.Add("Expression :" & valuef.Expression)
						lstValueFilter.Items.Add("FilterType :" & valuef.FilterType)
						lstValueFilter.Items.Add("Unique Field Name :" & valuef.FieldUniqueName)
						lstValueFilter.Items.Add("----------------------------------------------------")




					End If

					If CType(filter, Object).ToString().Contains("HeadingFilter") Then ' Check of the Filter Item contains the string HeadingFilter

						Dim heading As IHeadingFilter = CType(filter, IHeadingFilter) ' Typecase Filter item to instance of IHeadingFilter


						lstHeadingFilter.Items.Add("Filter Name" & CType(filter, Object).ToString())
						lstHeadingFilter.Items.Add("Value" & heading.Value)
						lstHeadingFilter.Items.Add("End Value" & heading.EndValue)
						lstHeadingFilter.Items.Add("FilterTyp" & heading.FilterType)
						lstHeadingFilter.Items.Add("Unique Field Name" & heading.FieldUniqueName)


						lstHeadingFilter.Items.Add("----------------------------------------------------")




					End If

			Next filter




		End Sub
	End Class
End Namespace

